"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const detect_node_1 = __importDefault(require("detect-node"));
const semver_compare_1 = __importDefault(require("semver-compare"));
const package_json_1 = require("../../package.json");
const createNodeWriter_1 = __importDefault(require("./createNodeWriter"));
exports.default = (currentState) => {
    const versions = (currentState.versions || []).concat();
    versions.sort(semver_compare_1.default);
    const currentIsLatestVersion = !versions.length || semver_compare_1.default(package_json_1.version, versions[versions.length - 1]) === 1;
    if (!versions.includes(package_json_1.version)) {
        versions.push(package_json_1.version);
    }
    versions.sort(semver_compare_1.default);
    let newState = {
        sequence: 0,
        ...currentState,
        versions,
    };
    if (detect_node_1.default && (currentIsLatestVersion || !newState.write)) {
        newState = {
            ...newState,
            ...createNodeWriter_1.default(),
        };
    }
    return newState;
};
